
% CFA / PAF  -- from Bernstein p 189   --  smc = from Bernstein p 104.
converge  = .001;

rcfa = r;
smc = 1 - (1 ./ diag(inv(rcfa)) );
for iter = 1:itercfa + 1
% putting smcs on the main diagonal of r	
rcfa = setdiagv(rcfa,smc);

[eigvect,eigval] = eig(rcfa);
eigval = diag(eigval);
% sorting the eigenvalues & eigenvectors.
[eigval,k] = sort(eigval*-1); eigval = eigval * -1;
eigvect = eigvect(:,k);

loadings = eigvect(:,1:nfactors) * sqrt( diag(eigval(1:nfactors,:),0) );
communal = sum((loadings.^2),2);
if  max(max(abs(communal-smc))) < converge ; break;end
if  max(max(abs(communal-smc))) > converge  & iter < itercfa;  smc=communal; end;
end;


if  max(max(abs(communal-smc))) < converge
%disp(['PAF converged in iterations = '  num2str(iter)]); disp([' ']);	
%disp(['Communalities: '])
%disp([communal])
%disp(['Unrotated PAF Loadings:'])
%disp([loadings(:,1:nfactors)])
%else; disp(['PAF did not converge in the following number of iterations:  ' num2str(iter-1) ])
end;


lding = loadings;





