% PCA
[eigvect,eigval] = eig(r);
eigval = diag(eigval);
% sorting the eigenvalues & eigenvectors.
[eigval,k] = sort(eigval*-1); eigval = eigval * -1;
eigvect = eigvect(:,k);
lding = eigvect(:,1:nfactors) * sqrt(diag( (eigval(1:nfactors,:)), 0 ));

% warning for negative eigenvalues
if min(eigval) < 0; 
disp(['Warning: There is a negative eigenvalue in the correlation matrix']);
disp(['']);disp(['']);end


